---------------------------------------------------------------------------
-- Mod P division. Euclidean Algorithm
---------------------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Galois; use Galois;
procedure Algorithm1 is
   X, Y, Z, A, B, C, D, Q, R, Next_D, W, xmodp: Integer;   
begin
   X := 137;
   for I in 1 .. P-1 loop
      Y := I;
      ---------------------------------------------------------------------
      A := P; B := Y; C := 0; D := X;
      while B > 1 loop
         Q := A/B; R := A mod B; Next_D := (C - D*Q) mod P;
         A := B; B := R; C := D; D := Next_D;
      end loop;
      Z := D;
      ----------------------------------------------------------------------
      Put(X);Put("/"); Put(Y); Put(" mod "); Put(P); Put(" = "); Put(Z);  New_Line;
      W := (Z*Y) mod p; xmodp := X mod p; 
      Put("z*y mod p= "); Put(W);  New_Line;
      if W /= xmodp then Put("ERROR"); end if; New_Line; New_Line;
   end loop;
end Algorithm1;

